/*
 * brightness.c
 *
 * Created: 27/09/2015 10:32:29
 *  Author: CPV
 */ 


#include "brightness.h"


// Brightness interrupt.
ISR(TIMER2_COMPA_vect)
{
	// This ISR must finish before the next systick ISR is called!
	
	// Disable interrupt on OCR2A
	TIMSK2 &= ~(1<<OCIE2A);
	// LEDs off.
	led_matrix_disconnect();
}


void brightness_init(void)
{
	// CTC mode (WGM0 = 0x02), Compare Match Outputs disabled.
	TCCR2A = (1<<WGM21);
	// Prescaler = 32 (CS0 = 0x03, this is different from timer0)
	TCCR2B = (1<<CS21) | (1<<CS20);
	// Use Output Compare A: 16 MHz / 32 / (brightness+1)
	OCR2A = BRIGHTNESS_MAX;
	// Do not enable interrupts here.
}
