/*
 * led_matrix.h
 *
 * Created: 21/09/2015 09:52:49
 *  Author: CPV
 */ 


#ifndef LED_MATRIX_H_
#define LED_MATRIX_H_


#include "Elektor.h"


#define RINGS  (6)
#define LEDS_PER_RING_MAX  (11)
#define ROWS  (6)
#define COLUMNS  (6)
#define LEDS  (ROWS*COLUMNS)
#define ROW_PORT  (PORTD)
#define ROW_PORT_DDR  (DDRD)
#define COL_PORT  (PORTB)
#define COL_PORT_DDR  (DDRB)


typedef enum
{
	black,
	white
}
led_matrix_color_t;


typedef struct
{
	uint8_t row;
	uint8_t column;
	led_matrix_color_t color;
	uint8_t timer; 
	uint8_t brightness;
}
led_matrix_led_t;


void led_matrix_init(void);
void led_matrix_set(uint8_t nr, led_matrix_color_t color);
void led_matrix_disconnect(void);
void led_matrix_connect(void);
void led_matrix_put_pixel(uint8_t nr, led_matrix_color_t color);
void led_matrix_set_timeout(uint8_t nr, uint8_t timeout);
void led_matrix_put_pixel_timeout(uint8_t nr, led_matrix_color_t color, uint8_t timeout);
led_matrix_color_t led_matrix_get_pixel(uint8_t nr);
void led_matrix_tick(void);
void led_matrix_tick_timeout(void);
void led_matrix_clear(void);
void led_matrix_set_all(void);
uint8_t led_matrix_led_to_ring(uint8_t nr);
uint8_t led_matrix_number_of_leds_on_ring(uint8_t nr);
void led_matrix_ring(uint8_t ring, led_matrix_color_t color);
void led_matrix_ring_timeout(uint8_t ring, led_matrix_color_t color, uint8_t timeout);
void led_matrix_ring_timeout_random(uint8_t ring, led_matrix_color_t color, uint8_t timeout_min);


#endif /* LED_MATRIX_H_ */