/*
 * running_led.h
 *
 * Created: 27/09/2015 10:09:54
 *  Author: CPV
 */ 


#ifndef RUNNING_LED_H_
#define RUNNING_LED_H_


#include "Elektor.h"
#include "led_matrix.h"


#define RUNNING_LEDS  (6)


typedef struct
{
	// Constants.
	uint32_t delay;
	int16_t speed_min;
	int16_t speed_max;
	int16_t acceleration;
	int8_t step;
	int16_t steps_to_take;
	led_matrix_color_t color;
	// Variables.
	int16_t speed;
	int8_t position;
	int16_t steps_taken;
	uint32_t life;
}
running_led_t;


void running_led_enable(uint8_t value);
void running_led_tick(running_led_t *p_led);
void running_led_tick_all(void);
void running_led_init(void);


#endif /* RUNNING_LED_H_ */