/*
 * trimmer.c
 *
 * Created: 24/09/2015 19:42:31
 *  Author: CPV
 */ 

#include "Elektor.h"


void trimmer_init(void)
{
	// PC2 & PC4 are digital outputs, PC3 is the analog input.
	DDRC = (1<<PORTC2) | (1<<PORTC4);
	// PC2=5V, PC4=0V.
	PORTC = 0x04;
	// Select AVCC (=VCC) as reference and PC3 as input.
	ADMUX = (1<<REFS0) | (1<<MUX1) | (1<<MUX0);
	// Disable digital input buffer on analog input (saves power).
	DIDR0 = (1<<ADC3D);
	// Enable ADC, prescaler of 128 (125 kHz).
	ADCSRA = (1<<ADEN) | 0x07;
}


uint16_t trimmer_read(void)
{
	// Start AD conversion.
	ADCSRA |= (1<<ADSC);
	// Wait for conversion to finish;
	while ((ADCSRA&(1<<ADSC))!=0)
	{
	}
	// Return conversion result.
	return ADC;
}
